//Please read the LICENSE.txt first
//These are all functions of special effects
//Don't delete this file if you don't want everything to be bugs
#include "noise.h"

const highp mat2 m = mat2(1.3,0.1,0.7,0.6);

highp float fbm1( highp vec2 p, highp float den){
	p += TIME*0.004;
   float f = den;
     f += 0.8*noise( p );
     p = m*p*2.0;
     f += -0.87500*noise( p );
     p = p*2.0*m;
     f += 0.15*noise(p);
    return f/1.9375;
}
					
highp float fbm2( highp vec2 p ){
   float f = -0.2;
     f += 0.8*noise( p );
     p = p*m*2.0+TIME*0.3;
     f += -0.9*noise( p );
    return f/1.9375;
}

highp vec3 aurora(highp vec2 uv){
	highp vec3 au = clamp(max(
						fbm2(uv*1.00)*vec3(0.2,2.,0.4),
						fbm2(uv*0.95)*vec3(0.72, 0.12, 1)), 0.0,1.0);
	return clamp(au,0.0,1.0);
	}
	
vec3 ACESFilm( vec3 x ) {
	float a = 4.6;
	float b = 0.1;
	float c = 3.6;
	float d = 0.48;
	float e = 0.6;
return((x*(a*x+b))/(x*( c * x + d ) + e ) );}